%% Cinematica inversa
function invp=cineinv(p)
fprintf('Cinematica inversa metodo geometrico \n');

a = 200; %Longitud del hombro
b = 250; %Longitud del brazo
c = 300; %Longitud del antebrazo
d = 150; %Longitud de la mueca + herramienta
%espacio = b+c+d;

% % Valores iniciales
% px = 0.3; %Posicion inicial de x
% py = 0; %Posicion inicial de y
% pz = 0.15; %Posicion inicial de z
% pitch = -90; 
% roll = 0;
%Toma de los valores de la posicion y orientacion del efector final
px=p(1);
py=p(2); 
pz=p(3); 
pitch=p(4); 
roll=p(5);

%Calculo theta 1
if (px~=0)
%theta1 = 180+atan2d(py,px); %atan(py/px)*180/pi
theta1 = atan2d(py,px);
  if (theta1<=-150)&&(theta1>=150)
      display('Error singularidad en theta1 valor no alcanzable');
      display('Recalculando valor');
      if theta1<-150;
        theta1=-150;
      else
        theta1=150;
      end
      %return;
  end
else
%theta1 = 180+atand(py/px);
theta1 = atand(py/px);
end
if (px==0)&&(py==0)
        %theta1 = 180;
        theta1 = 180;
end
%Hipotenusa que crea el brazo robot con respecto a las articulaciones Q2,Q3
%y Q4
r = sqrt(abs(px^2)+abs(py^2));

%Calculo theta 2
fx = d*cosd(pitch);
lx = r-fx;
fy = d*sind(pitch);
ly = pz-fy-a;
l = sqrt(lx^2+ly^2); %Hipotenusa del triangulo formado por b y c
alfa = atand(ly/lx);
beta = acosd((b^2+l^2-c^2)/(2*b*l));

    theta2 =(-(alfa+beta));
    if (px==0)&&(py==0)
        theta2 =(-90);
    end

%Calculo theta 3
gamma = (acosd((b^2+c^2-l^2)/(2*b*c)));

    theta3 = 180-gamma;
    if (px==0)&&(py==0)
        theta3 = 0;
    end

%Calculo theta 4

    theta4 = 360-90+(-pitch-theta2-theta3);

theta5 = roll;
invp=[theta1,theta2,theta3,theta4,theta5];

if (alfa+beta<=120) && (alfa+beta>=-60)
    if (rad2deg(-(pi-gamma))<=120)&&(rad2deg(-(pi-gamma))>=-110)
        px=auxpx;
        py=auxpy;
        pz=auxpz;
        pitch=auxpitch;
        roll=auxroll;
        return
    end
end


end