/**********************************************************************************
*	ARCHIVO: GLOBAL_DEFS.h
*	DEFINICIONES GLOBALES
*	AUTOR: P.TRUJILLO (2/4/2013)
*	FRENO EOLICO BORNAY
**********************************************************************************/

#define TRUE 1
#define FALSE 0


//	FRECUENCIAS DE SISTEMA

#define SYSCLK	60000000
#define LSCLK	SYSCLK/(2*SysCtrlRegs.LOSPCP.bit.LSPCLK)


//	LECTURAS CONVERSOR ANALOGICO-DIGITAL

#define fb_temp	        AdcResult.ADCRESULT0	//	TEMPERATURA
#define fb_IN_BOOST	    AdcResult.ADCRESULT1	//	TENSION BAja_Tension. Entrada del BOOST
#define fb_IN_BUCK	    AdcResult.ADCRESULT2	// 	TENSIN Entrada_BUCK
#define fb_IDC_BOOST	AdcResult.ADCRESULT3	// 	CORRIENTE BOOST
#define fb_IDC_BUCK	    AdcResult.ADCRESULT4	// 	CORRIENTE BUCK

//	PERDIODO DEL PWM

#define PWM_PRD75 6249
#define PWM_PRD50 9371
#define PWM_PRD25 18742


//	CONTROL DE LOS PWM

#define PWM_OFF() 	(GpioCtrlRegs.GPAMUX1.all &= 0xFFF0)
#define PWM_ON() 	(GpioCtrlRegs.GPAMUX1.all |= 0x000F);


//	FONDOS DE ESCALA PARA LOS REGULADORES

#define velocidad_maxima	300
#define corriente_maxima	50

