%% Generacion de trayectoria o control cinematico
% Funcin que genera la trayectoria punto a punto 
% Usando un polinomio de cuarto orden

function [qp] = controlcinevel(qi,qf,tf)

poli = [];
polip = [];
q = [];
qp = [];
% Condiciones de contorno thetap0=thetapp0=thetappf=0
% thetaf-theta0=(tf/2)(thetapf+thetap0)

for i=0:0.1:tf
    for j=1:1:length(qi/tf)
        a=(qi(j)*tf^3*(tf^2)/(tf^5));
        b=0;
        c=0;
        d=(qf(j)*(10*tf^2)/tf^5)-(qi(j)*(10*tf^2)/tf^5);
        e=(qi(j)*(15*tf)/tf^5)-(qf(j)*(15*tf)/tf^5);
        f=6*qf(j)/tf^5-6*qi(j)/tf^5;      
        poli(j) = (f*i^5 + e*i^4 + d*i^3 + c*i^2 + b*i + a); 
        polip(j) = (5*f*i^4 + 4*e*i^3 + 3*d*i^2 + 2*c +b);
    end
[q] = [q;poli]; %Matriz de la trayectoria
[qp] = [qp;polip];
end
% Condiciones de contorno thetap0=thetapp0=thetappf=0
end