/**********************************************************************************
*	ARCHIVO: GLOBAL_FUNCS.h
*	PROTOTIPOS DE FUNCIONES GLOBALES
*	AUTOR: P.TRUJILLO (2/4/2013)
*	FRENO EOLICO BORNAY
**********************************************************************************/


//	FUNCIONES INICIALIZACIN

void DeviceInit(void);
void InitFlash();
void InitDSP();
void InitADC();
void ADC_SOC_CNF(int ChSel[], int Trigsel[], int ACQPS[], int IntChSel, int mode);
void InitPWM();
void InitTimers();
void InitSci(void);
void InitInt();
void InitRegula();

//	INTERRUPCIONES DE PERIFERICOS

//	TIMERS
interrupt void TA0_Cpu_Timer0_isr(void);
interrupt void TB0_Cpu_Timer1_isr(void);
interrupt void TC0_Cpu_Timer2_isr(void);
// 	ePWM
interrupt void ePWM1_isr(void);
interrupt void ePWM2_isr(void);
interrupt void ePWM3_isr(void);

//	SCI
interrupt void SCIA_RXFIFO_isr(void);

// XINT1
interrupt void xint1_isr(void);

//Funciones de control
void Lectura_Datos();
void Define_Modo();
void Calculo_Control();

